% Program to convert files in "system/" directory into the book.
% This program is in public domain.

\font\titlefont=cmr10 scaled \magstep2 %

\let\:=\.%

\def\.#1{{%
  \def\ {\phantom{x}}%
  \def\~{\char`\~\relax}%
  \def\#{\char`\#\relax}%
  \def\${\char`\$\relax}%
  \def\%{\char`\%\relax}%
  \def\^{\char`\^\relax}%
  \def\&{\char`\&\relax}%
  \def\_{\char`\_\relax}%
  \def\\{\char`\\\relax}%
  \def\{{\char`\{\relax}%
  \def\}{\char`\}\relax}%
  \let\@=\atcmd%
  \tt#1%
}}%

\def\atcmd#1{%
  \ifnum`#1=`@%
    @%
  \else%
    \ifnum`#1=`.%
      \kern5pt$\bullet$\kern7pt%
    \else%
      \ifnum`#1=`&%
        $\wr$%
      \else%
        \Atcmd#1%
      \fi%
    \fi%
  \fi%
}%

\def\Atcmd#1{%
  \ifnum`#1=`^%
    \rlap{\accent`\^\^}\kern.25em%
  \else%
    \ifnum`#1=`(%
      \rlap{\char"16}\rlap{\_}(%
    \else%
      $\langle{\bf#1}\rangle$%
    \fi%
  \fi%
}%

\def\chapterheading#1{%
  \par\filbreak\kern13pt\hrule\kern9pt\noindent{\titlefont#1}\par%
}%

\def\beforecode{\par\kern7pt}%

\def\code#1{\line{\.{#1}\hfil}}%

\immediate\openout1=\jobname.idx%

\output={%
  \def\_{//}%
  \plainoutput%
}%

\def\indexentry#1{%
  \write1{%
    \noexpand\expandafter\gdef\noexpand\csname.#1\noexpand\endcsname%
    {\the\pageno}%
  }%
}%

\let\enddoc=\bye%

\def\beginindex{%
  \closeout1\vfil\eject\vfilneg%
  \chapterheading{ Index}\par\line{\hss}%
  \def\_{//}%
  \input\jobname.idx\relax%
}%

\def\Ix#1{%
  \line{\.{#1}: \csname.#1\endcsname\hfil}%
}%
